=== modified file 'olive/__init__.py'
--- olive/__init__.py	2006-09-30 08:48:46 +0000
+++ olive/__init__.py	2006-09-30 09:09:18 +0000
@@ -201,7 +201,7 @@
     def on_menuitem_branch_get_activate(self, widget):
         """ Branch/Get... menu handler. """
         from branch import OliveBranch
-        branch = OliveBranch()
+        branch = OliveBranch(self.get_path())
         branch.display()
     
     def on_menuitem_branch_checkout_activate(self, widget):
@@ -572,28 +572,9 @@
         tvcolumn_filename.add_attribute(cell, 'text', 1)
         tvcolumn_status.pack_start(cell, True)
         tvcolumn_status.add_attribute(cell, 'text', 2)
-
-        # Set menu and toolbar sensitivity
-        self.menuitem_branch_init.set_sensitive(self.notbranch)
-        self.menuitem_branch_get.set_sensitive(not self.notbranch)
-        self.menuitem_branch_checkout.set_sensitive(not self.notbranch)
-        self.menuitem_branch_pull.set_sensitive(not self.notbranch)
-        self.menuitem_branch_push.set_sensitive(not self.notbranch)
-        self.menuitem_branch_commit.set_sensitive(not self.notbranch)
-        self.menuitem_branch_status.set_sensitive(not self.notbranch)
-        self.menuitem_branch_missing.set_sensitive(not self.notbranch)
-        self.menuitem_stats.set_sensitive(not self.notbranch)
-        self.menuitem_add_files.set_sensitive(not self.notbranch)
-        self.menuitem_remove_files.set_sensitive(not self.notbranch)
-        self.menuitem_file_make_directory.set_sensitive(not self.notbranch)
-        self.menuitem_file_rename.set_sensitive(not self.notbranch)
-        self.menuitem_file_move.set_sensitive(not self.notbranch)
-        #self.menutoolbutton_diff.set_sensitive(True)
-        self.toolbutton_diff.set_sensitive(not self.notbranch)
-        self.toolbutton_log.set_sensitive(not self.notbranch)
-        self.toolbutton_commit.set_sensitive(not self.notbranch)
-        self.toolbutton_pull.set_sensitive(not self.notbranch)
-        self.toolbutton_push.set_sensitive(not self.notbranch)
+        
+        # Set sensitivity
+        self.set_sensitivity()
         
     def get_selected_right(self):
         """ Get the selected filename. """
@@ -623,6 +604,29 @@
         """ Clean the last message from the statusbar. """
         self.statusbar.pop(self.context_id)
     
+    def set_sensitivity(self):
+        """ Set menu and toolbar sensitivity. """
+        self.menuitem_branch_init.set_sensitive(self.notbranch)
+        self.menuitem_branch_get.set_sensitive(self.notbranch)
+        self.menuitem_branch_checkout.set_sensitive(self.notbranch)
+        self.menuitem_branch_pull.set_sensitive(not self.notbranch)
+        self.menuitem_branch_push.set_sensitive(not self.notbranch)
+        self.menuitem_branch_commit.set_sensitive(not self.notbranch)
+        self.menuitem_branch_status.set_sensitive(not self.notbranch)
+        self.menuitem_branch_missing.set_sensitive(not self.notbranch)
+        self.menuitem_stats.set_sensitive(not self.notbranch)
+        self.menuitem_add_files.set_sensitive(not self.notbranch)
+        self.menuitem_remove_files.set_sensitive(not self.notbranch)
+        self.menuitem_file_make_directory.set_sensitive(not self.notbranch)
+        self.menuitem_file_rename.set_sensitive(not self.notbranch)
+        self.menuitem_file_move.set_sensitive(not self.notbranch)
+        #self.menutoolbutton_diff.set_sensitive(True)
+        self.toolbutton_diff.set_sensitive(not self.notbranch)
+        self.toolbutton_log.set_sensitive(not self.notbranch)
+        self.toolbutton_commit.set_sensitive(not self.notbranch)
+        self.toolbutton_pull.set_sensitive(not self.notbranch)
+        self.toolbutton_push.set_sensitive(not self.notbranch)
+    
     def refresh_left(self):
         """ Refresh the bookmark list. """
         
@@ -741,27 +745,8 @@
         # Add the ListStore to the TreeView
         self.treeview_right.set_model(liststore)
         
-        # Set menu and toolbar sensitivity
-        self.menuitem_branch_init.set_sensitive(self.notbranch)
-        self.menuitem_branch_get.set_sensitive(not self.notbranch)
-        self.menuitem_branch_checkout.set_sensitive(not self.notbranch)
-        self.menuitem_branch_pull.set_sensitive(not self.notbranch)
-        self.menuitem_branch_push.set_sensitive(not self.notbranch)
-        self.menuitem_branch_commit.set_sensitive(not self.notbranch)
-        self.menuitem_branch_status.set_sensitive(not self.notbranch)
-        self.menuitem_branch_missing.set_sensitive(not self.notbranch)
-        self.menuitem_stats.set_sensitive(not self.notbranch)
-        self.menuitem_add_files.set_sensitive(not self.notbranch)
-        self.menuitem_remove_files.set_sensitive(not self.notbranch)
-        self.menuitem_file_make_directory.set_sensitive(not self.notbranch)
-        self.menuitem_file_rename.set_sensitive(not self.notbranch)
-        self.menuitem_file_move.set_sensitive(not self.notbranch)
-        #self.menutoolbutton_diff.set_sensitive(True)
-        self.toolbutton_diff.set_sensitive(not self.notbranch)
-        self.toolbutton_log.set_sensitive(not self.notbranch)
-        self.toolbutton_commit.set_sensitive(not self.notbranch)
-        self.toolbutton_pull.set_sensitive(not self.notbranch)
-        self.toolbutton_push.set_sensitive(not self.notbranch)
+        # Set sensitivity
+        self.set_sensitivity()
 
     def _harddisks(self):
         """ Returns hard drive letters under Win32. """

=== modified file 'olive/branch.py'
--- olive/branch.py	2006-09-27 20:30:59 +0000
+++ olive/branch.py	2006-09-30 09:09:18 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import sys
+import os
 
 try:
     import pygtk
@@ -25,8 +25,11 @@
 import gtk
 import gtk.glade
 
+from bzrlib.branch import Branch
 import bzrlib.errors as errors
-from __init__ import gladefile
+
+from olive import gladefile
+from dialog import error_dialog, info_dialog
 
 class OliveBranch:
     """ Display branch dialog and perform the needed operations. """
@@ -57,20 +60,21 @@
         location = entry_location.get_text()
         if location is '':
             error_dialog(_('Missing branch location'),
-                                     _('You must specify a branch location.'))
+                         _('You must specify a branch location.'))
             return
         
         destination = self.filechooser.get_filename()
         
         spinbutton_revno = self.glade.get_widget('spinbutton_branch_revno')
         revno = spinbutton_revno.get_value_as_int()
-        revision_id = br_from.get_rev_id(revno)
         
         try:
             from bzrlib.transport import get_transport
 
             br_from = Branch.open(location)
             br_from.lock_read()
+            
+            revision_id = br_from.get_rev_id(revno)
 
             try:
                 destination = destination + '/' + os.path.basename(location.rstrip("/\\"))
@@ -80,7 +84,8 @@
                 try:
                     dir = br_from.bzrdir.sprout(to_transport.base, revision_id)
                     branch = dir.open_branch()
-                except NoSuchRevision:
+                    revs = branch.revno()
+                except errors.NoSuchRevision:
                     to_transport.delete_tree('.')
                     raise
 
@@ -92,25 +97,24 @@
                         _('%d revision(s) branched.') % revs)
         except errors.NonExistingSource, errmsg:
             error_dialog(_('Non existing source'),
-                                     _("The location (%s)\ndoesn't exist.") % errmsg)
+                         _("The location (%s)\ndoesn't exist.") % errmsg)
             return
         except errors.TargetAlreadyExists, errmsg:
             error_dialog(_('Target already exists'),
-                                     _('Target directory (%s)\nalready exists. Please select another target.') % errmsg)
+                         _('Target directory (%s)\nalready exists. Please select another target.') % errmsg)
             return
         except errors.NonExistingParent, errmsg:
             error_dialog(_('Non existing parent directory'),
-                                     _("The parent directory (%s)\ndoesn't exist.") % errmsg)
+                         _("The parent directory (%s)\ndoesn't exist.") % errmsg)
             return
         except errors.NonExistingRevision:
             error_dialog(_('Non existing revision'),
-                                     _("The revision you specified doesn't exist."))
+                         _("The revision you specified doesn't exist."))
             return
         except errors.NotBranchError, errmsg:
             error_dialog(_('Location is not a branch'),
-                                     _('The specified location has to be a branch.'))
+                         _('The specified location has to be a branch.'))
             return
         
-
     def close(self, widget=None):
         self.window.destroy()

